#
# CSCIE-236 Homework 2      
# Russell Lowke  March 22nd 2005
#
# Question 5.1  Prepare image data for visualization - 10pts
#
# Download Monkey Brain data from http://mallorn.ucdavis.edu/conexus/data/mri-e22351s21/
# and convert this data into the same spacial data used in previous section
# 
# ... when convverting C++ to TCL
# anActor->GetProperty()->SetColor(red, green, blue);     is
# [anActor GetProperty] SetColor $red $green $blue

#
# First include the VTK Tcl packages which will make available 
# all of the vtk commands to Tcl
#
package require vtk
package require vtkinteraction
package require vtktesting

# dimensions of Monkey Brain, number of images, image width, and image height
set nImages 123
set imageX 256
set imageY 256
# number of voxels per slice
set sliceSize [expr $imageX*$imageY]

# convert .pgm files to .vtk structured points
for {set i 1} {$i <= $nImages} {incr i} {

	if { $i < 10 } { 
		set prefix "000"
	} elseif { $i < 100 } {
		set prefix "00" 
	} else { 
		set prefix "0" 
	}
	
	puts "converting $prefix$i.pgm to a vtk structuredPoints .vtk file"
	vtkPNMReader reader
	 reader SetFileName "MonkeyBrain_pgm/$prefix$i.pgm"

	vtkImageCast cast
	 cast SetInput [reader GetOutput]
	 cast SetOutputScalarTypeToUnsignedShort

	# save out the structured points data
	vtkStructuredPointsWriter writer
	 writer SetInput [cast GetOutput]
	 writer SetFileName "MonkeyBrain_vtk/MonkeyBrain.$i"
	 writer SetFileTypeToBinary
	 writer Write

	# Clean up
	vtkCommand DeleteAllObjects
}

# initialize a ruling single structured points volume
puts "creating volume data"
vtkStructuredPoints volume
 volume SetDimensions $imageX $imageY $nImages
 volume SetOrigin 0 0 0
 volume SetSpacing 1 1 1
vtkFloatArray scalars
 scalars SetNumberOfValues $sliceSize
 
# n used as counter to voxel being processed
set n 0
for {set j 1} {$j <= $nImages} {incr j} {

	puts "reading slice $j and adding it, point by point, to a single volume"
	
	# create a reader for the slice
	vtkStructuredPointsReader "reader$j"
	 "reader$j" SetFileName "MonkeyBrain_vtk/MonkeyBrain.$j"
	 "reader$j" Update
 
 	# add the slice to the volume
	for {set i 0} {$i < $sliceSize} {incr i} {
		# add the voxel
		scalars InsertValue $n [[[["reader$j" GetOutput] GetPointData] GetScalars] GetValue $i]
		# get next voxel
		incr n
	}
}
 
puts "Saving the volume as a single StructuredPoints file"
# assign scalers to structuredPoints
[volume GetPointData] SetScalars scalars
  
# important part, save out the structured points data
vtkStructuredPointsWriter writer
 writer SetInput volume
 writer SetFileName "MonkeyBrain.vtk"
 writer SetFileTypeToBinary
 writer Write
 
# Clean up and end
vtkCommand DeleteAllObjects
puts end
exit