#
# CSCIE-236 Homework 2      
# Russell Lowke  March 22nd 2005
#
# Question 5.2  Render the image data using Marching Cubes - 10pts
#
# Render surface of Monkey Brain using appropriate iso-value
# 
# I've chosen an iso value of 20.268
#
# I can't seem to separate the skin from the brain easily as they have
#  very similar iso values
#
# ... when convverting C++ to TCL
# anActor->GetProperty()->SetColor(red, green, blue);     is
# [anActor GetProperty] SetColor $red $green $blue

#
# First include the VTK Tcl packages which will make available 
# all of the vtk commands to Tcl
#
package require vtk
package require vtkinteraction
package require vtktesting

set file_name "MonkeyBrain.vtk"

vtkStructuredPointsReader reader
  reader SetFileName $file_name
  reader Update
  
# create a renderer and render window
vtkRenderer renderer
vtkRenderWindow renWin
 renWin AddRenderer renderer

vtkRenderWindowInteractor iren
 iren SetRenderWindow renWin
  
# find the contour value for this iteration
set val 20.268
puts "Rendering $file_name using an iso contour value of $val"
puts "Please wait, it takes time to generate 3D contours..."
    
# create iso-surface
vtkContourFilter contour
 contour SetInput [reader GetOutput]
 contour SetValue 0 $val

# create mapper 
vtkPolyDataMapper mapper
 mapper SetInput [contour GetOutput]
 mapper ScalarVisibilityOff

# create actor
vtkActor actor
 actor SetMapper mapper
 [actor GetProperty] SetColor 0.6 0.8 0.8
      
renderer AddActor actor


# render window parameters
renderer SetBackground 1 1 1
renWin SetSize 500 500

# turn the data $turns times
proc turn_cube { turns } {
	for {set i 0} {$i<$turns} {incr i} {
		[renderer GetActiveCamera] Azimuth 1
		[renderer GetActiveCamera] Roll 1
		renWin Render
	}
}

turn_cube 126

puts "Now you may interact with the data"

# interact with data
iren Start

# Clean up and end
vtkCommand DeleteAllObjects
puts end

exit